diff -urN linux.store/linux/include/asm-arm/proc-arm6/ptrace.h linux/include/asm-arm/proc-arm6/ptrace.h
--- linux.store/linux/include/asm-arm/proc-arm6/ptrace.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm6/ptrace.h	Sun Feb 11 09:32:54 1996
@@ -0,0 +1,15 @@
+/*
+ * linux/include/asm-arm/proc-arm6/ptrace.h
+ *
+ * Copyright (C) 1996 Russell King
+ */
+
+#ifndef __ASM_PROC_PTRACE_H
+#define __ASM_PROC_PTRACE_H
+
+#error Have to modify this
+#define user_mode(regs)			(((regs)->ARM_pc & 3) == 0)
+#define instruction_pointer(regs)	((regs)->ARM_pc & 0x03fffffc)
+
+#endif
+
diff -urN linux.store/linux/include/asm-arm/proc-arm6/shmparam.h linux/include/asm-arm/proc-arm6/shmparam.h
--- linux.store/linux/include/asm-arm/proc-arm6/shmparam.h	Thu Jan  1 01:00:00 1970
+++ linux/include/asm-arm/proc-arm6/shmparam.h	Sun Feb 11 09:32:56 1996
@@ -0,0 +1,12 @@
+/*
+ * linux/include/asm-arm/proc-arm6/shmparam.h
+ *
+ * Copyright (C) 1996 Russell King
+ *
+ * definitions for the shared process memory on the ARM6
+ */
+
+#ifndef SHM_RANGE_START
+#define SHM_RANGE_START	0x50000000
+#define SHM_RANGE_END	0x60000000
+#endif
diff -urN linux.store/linux/include/asm-arm/ptrace.h linux/include/asm-arm/ptrace.h
--- linux.store/linux/include/asm-arm/ptrace.h	Sun Feb 11 09:32:56 1996
+++ linux/include/asm-arm/ptrace.h	Sun Feb 11 09:32:56 1996
@@ -28,8 +28,7 @@
 #define ARM_ORIG_r0	uregs[16] /* -1 */
 
 #ifdef __KERNEL__
-#define user_mode(regs)			(((regs)->ARM_pc & 3) == 0)
-#define instruction_pointer(regs)	((regs)->ARM_pc & 0x03fffffc)
+#include <asm/proc/ptrace.h>
 extern void show_regs(struct pt_regs *);
 #endif
 
diff -urN linux.store/linux/include/asm-arm/segment.h linux/include/asm-arm/segment.h
--- linux.store/linux/include/asm-arm/segment.h	Sun Feb 11 09:32:56 1996
+++ linux/include/asm-arm/segment.h	Sun Feb 11 09:32:56 1996
@@ -40,136 +40,11 @@
  */
 extern int bad_user_access_length(void);
 
-/*
- * dummy pointer type structure.. gcc won't try to do something strange
- * this way..
- */
-struct __segment_dummy { unsigned long a[100]; };
-#define __sd(x) ((struct __segment_dummy *) (x))
-#define __const_sd(x) ((const struct __segment_dummy *) (x))
-
-#if defined(__arm2__) || defined(__arm3__)
-/*
- * These *have* to tell gcc that lr may be clobbered (if there is an abort)
- * and the psw (if it tries too hard to optimize this
- */
-static inline void __put_user(unsigned long x, void * y, int size)
-{
-	if (IS_USER_SEG) {
-		switch (size) {
-			case 1:
-				__asm__(
-				" strbt	%0, [%1]\n"
-				: : "r" (x), "r" (y)
-				: "lr", "cc");
-				break;
-			case 2:
-				{ register unsigned long tmp;
-				__asm__ __volatile__(
-				" strbt %1, [%2], #1\n"
-				" mov   %0, %1, lsr #8\n"
-				" strbt %0, [%2]\n"
-				: "=&r" (tmp)
-				: "r" (x), "r" (y)
-				: "2", "lr", "cc");
-				}
-				break;
-			case 4:
-				if ((int)y & 3) {
-				register unsigned long tmp;
-				__asm__ __volatile__(
-				" strbt %1, [%2], #1\n"
-				" mov   %0, %1, lsr #8\n"
-				" strbt %0, [%2], #1\n"
-				" mov   %0, %0, lsr #8\n"
-				" strbt %0, [%2], #1\n"
-				" mov   %0, %0, lsr #8\n"
-				" strbt %0, [%2]\n"
-				: "=&r" (tmp)
-				: "r" (x), "r" (y)
-				: "2", "lr", "cc");
-				} else {
-				__asm__(
-				" strt  %0, [%1]\n"
-				: : "r" (x), "r" (y)
-				: "lr", "cc");
-				}
-				break;
-			default:
-				bad_user_access_length();
-		}
-	} else {
-		switch (size) {
-			case 1: *(unsigned char *)y = x; break;
-			case 2: *(unsigned short *)y = x; break;
-			case 4: *(unsigned long *)y = x; break;
-			default:
-				bad_user_access_length();
-		}
-	}
-}
-
-static inline unsigned long __get_user(const void *y, int size)
-{
-	unsigned long result1, result2;
-
-	if (IS_USER_SEG) {
-		switch (size) {
-			case 1:
-				__asm__(
-				" ldrbt %0, [%1]\n"
-				: "=r" (result1)
-				: "r" (y)
-				: "lr", "cc");
-				return result1;
-			case 2:
-				__asm__(
-				" ldrbt %0, [%2], #1\n"
-				" ldrbt %1, [%2]\n"
-				" orr   %0, %0, %1, lsl #8\n"
-				: "=&r" (result1), "=r" (result2)
-				: "r" (y)
-				: "lr", "cc");
-				return result1;
-			case 4:
-				if ((int)y & 3) {
-				__asm__(
-				" ldrt %0, [%2], #4\n"
-				" ldrt %1, [%2]\n"
-				: "=&r" (result1), "=r" (result2)
-				: "r" ((int)y & ~3)
-				: "lr", "cc");
-				result1 >>= ((int)y & 3)*8;
-				return result1 | (result2 << (32-((int)y & 3)*8));
-				} else {
-				__asm__(
-				" ldrt %0, [%1]\n"
-				: "=r" (result1)
-				: "r" (y)
-				: "lr", "cc");
-				return result1;
-				}
-			default:
-				return bad_user_access_length();
-		}
-	} else {
-		switch (size) {
-			case 1: return *(unsigned char *)y; break;
-			case 2: return *(unsigned short *)y; break;
-			case 4: return *(unsigned long *)y; break;
-			default:
-				return bad_user_access_length();
-		}
-	}
-}		
-#else
-#error Adjust this for your processor
-#endif
+#include <asm/proc/segment.h>
 
 /*
  * these are depreciated..
  */
-
 static __INLINE__ unsigned char get_user_byte(const char *addr)
 {
 	return __get_user(addr, 1);
diff -urN linux.store/linux/include/asm-arm/shmparam.h linux/include/asm-arm/shmparam.h
--- linux.store/linux/include/asm-arm/shmparam.h	Sun Feb 11 09:32:56 1996
+++ linux/include/asm-arm/shmparam.h	Sun Feb 11 09:32:56 1996
@@ -1,9 +1,13 @@
 #ifndef _ASMARM_SHMPARAM_H
 #define _ASMARM_SHMPARAM_H
 
-/* address range for shared memory attaches if no address passed to shmat() */
-#define SHM_RANGE_START	0x00a00000
-#define SHM_RANGE_END	0x00c00000
+/*
+ * Include the machine specific shm parameters before the processor
+ * dependent parameters so that the machine parameters can override
+ * the processor parameters
+ */
+#include <asm/arch/shmparam.h>
+#include <asm/proc/shmparam.h>
 
 /*
  * Format of a swap-entry for shared memory pages currently out in
diff -urN linux.store/linux/include/asm-arm/system.h linux/include/asm-arm/system.h
--- linux.store/linux/include/asm-arm/system.h	Sun Feb 11 09:32:57 1996
+++ linux/include/asm-arm/system.h	Sun Feb 11 09:32:57 1996
@@ -7,7 +7,6 @@
 extern void arm_invalidptr(const char *, void *, int);
 
 /* This special macro can be used to load a debugging register */
-
 #define loaddebug(register)
 
 /*
@@ -22,184 +21,13 @@
 #define xchg(ptr,x) ((__typeof__(*(ptr)))__xchg((unsigned long)(x),(ptr),sizeof(*(ptr))))
 #define tas(ptr) (xchg((ptr),1))
 
-struct __xchg_dummy { unsigned long a[100]; };
-#define __xg(x) ((volatile struct __xchg_dummy *)(x))
-
-#if defined (__arm2__)
-static inline unsigned long __xchg(unsigned long x, volatile void *ptr, int size)
-{
-	unsigned long temp0, temp1;
-	switch (size) {
-		case 1: __asm__ __volatile__(
-			" mov   %0, pc\n"
-			" orr   %1, %0, #0x08000000\n"
-			" teqp  %1, #0\n"
-			" mov   %1, %3\n"	/* Safe: in case it uses the same reg */
-			" ldrb  %2, [%4]\n"
-			" strb  %1, [%4]\n"
-			" teqp  %0, #0\n"
-			: "=r" (temp0), "=r" (temp1), "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			break;
-		case 2: { unsigned long temp0, temp1;
-			if (((long)ptr) & 1)
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_malalignedptr("xchg", pc, ptr);
-			}
-			__asm__ __volatile__(
-			" mov   %0, pc\n"
-			" orr   %1, %0, #0x08000000\n"
-			" teqp  %1, #0\n"
-			" mov   %1, %3\n"
-			" ldr	%2, [%4]\n"
-			" strb  %1, [%4]\n"
-			" mov   %1, %1, lsr #8\n"
-			" strb  %1, [%4, #1]\n"
-			" teqp  %0, #0\n"
-			: "=r" (temp0), "=r" (temp1), "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			val &= 0xffff;
-			break;
-			}
-		case 4: { unsigned long temp0, temp1;
-			if (((long)ptr) & 3)
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_malalignedptr("xchg", pc, ptr);
-			}
-			__asm__ __volatile__(
-			" mov   %0, pc\n"
-			" orr   %1, %0, #0x08000000\n"
-			" teqp  %1, #0\n"
-			" mov   %1, %3\n"
-			" ldr   %2, [%4]\n"
-			" str   %1, [%4]\n"
-			" teqp  %0, #0\n"
-			: "=r" (temp0), "=r" (temp1), "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			}
-			break;
-		default:
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_invalidptr("xchg", pc, size);
-				x = 0;
-			}
-	}
-	return x;
-}
-#elif defined (__arm3__)
-static inline unsigned long __xchg(unsigned long x, volatile void *ptr, int size)
-{
-	switch (size) {
-		case 1:
-			__asm__ __volatile__(
-			" swpb   %0, %1, [%2]\n\t"
-			: "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			break;
-		case 2: { unsigned long temp0, temp1;
-			if (((long)ptr) & 1)
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_malalignedptr("xchg", pc, ptr);
-			}
-			__asm__ __volatile__(
-			" mov   %0, pc\n"
-			" orr   %1, %0, #0x08000000\n"
-			" teqp  %1, #0\n"
-			" mov   %1, %3\n"
-			" ldr	%2, [%4]\n"
-			" strb  %1, [%4]\n"
-			" mov   %1, %1, lsr #8\n"
-			" strb  %1, [%4, #1]\n"
-			" teqp  %0, #0\n"
-			: "=r" (temp0), "=r" (temp1), "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			x &= 0xffff;
-			break;
-			}
-		case 4: if (((long)ptr) & 3)
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_malalignedptr("xchg", pc, ptr);
-			}
-			__asm__ __volatile__(
-			" swp   %0, %1, [%2]\n"
-			: "=r" (x)
-			: "r" (x), "r" (ptr)
-			: "memory");
-			break;
-		default:
-			{
-				void *pc;
-				__asm__("mov\t%0, pc": "=r" (pc));
-				arm_invalidptr("xchg", pc, size);
-				x = 0;
-			}
-	}
-	return x;
-}
-#else
-#error Adjust this routine for your processor
-#endif
+/*
+ * Include processor dependent parts
+ */
+#include <asm/proc/system.h>
+#include <asm/arch/system.h>
 
 #define mb() __asm__ __volatile__ ("" : : : "memory")
-
-#define sti()				\
-	do {				\
-	  unsigned long temp;		\
-	  __asm__ __volatile__(		\
-	  " mov %0, pc\n"		\
-	  " bic %0, %0, #0x08000000\n"	\
-	  " teqp %0, #0\n"		\
-	  : "=r" (temp)			\
-	  : );				\
-	} while(0)
-
-#define cli()				\
-	do {				\
-	  unsigned long temp;		\
-	  __asm__ __volatile__(		\
-	  " mov %0, pc\n"		\
-	  " orr %0, %0, #0x08000000\n"	\
-	  " teqp %0, #0\n"		\
-	  : "=r" (temp)			\
-	  : );				\
-	} while(0)
-
-#define save_flags(x)			\
-	do {				\
-	  __asm__ __volatile__(		\
-	  " mov %0, pc\n"		\
-	  : "=r" (x) : );		\
-	} while (0)
-
-#define restore_flags(x)		\
-	do {				\
-	  unsigned long temp;		\
-	  __asm__ __volatile__(		\
-	  " mov %0, pc\n"		\
-	  " bic %0, %0, #0x08000000\n"	\
-	  " and %1, %1, #0x08000000\n"	\
-	  " orr %0, %0, %1\n"		\
-	  " teqp %0, #0\n"		\
-	  : "=r" (temp)			\
-	  : "r" (x)			\
-	  : "cc");			\
-	} while (0)
-
 #define nop() __asm__ __volatile__("mov r0,r0\n\t");
 
 #endif
diff -urN linux.store/linux/include/linux/fd1772.h linux/include/linux/fd1772.h
--- linux.store/linux/include/linux/fd1772.h	Thu Jan  1 01:00:00 1970
+++ linux/include/linux/fd1772.h	Wed Mar 13 14:56:15 1996
@@ -0,0 +1,80 @@
+#ifndef _LINUX_FD1772REG_H
+#define _LINUX_FD1772REG_H
+
+/*
+** WD1772 stuff - originally from the M68K Linux
+ * Modified for Archimedes by Dave Gilbert (gilbertd@cs.man.ac.uk)
+ */
+
+/* register codes */
+
+#define FDC1772SELREG_STP   (0x80)   /* command/status register */
+#define FDC1772SELREG_TRA   (0x82)   /* track register */
+#define FDC1772SELREG_SEC   (0x84)   /* sector register */
+#define FDC1772SELREG_DTA   (0x86)   /* data register */
+
+/* register names for FDC1772_READ/WRITE macros */
+
+#define FDC1772REG_CMD		0
+#define FDC1772REG_STATUS	0
+#define FDC1772REG_TRACK	2
+#define FDC1772REG_SECTOR	4
+#define FDC1772REG_DATA		6
+
+/* command opcodes */
+
+#define FDC1772CMD_RESTORE  (0x00)   /*  -                   */
+#define FDC1772CMD_SEEK     (0x10)   /*   |                  */
+#define FDC1772CMD_STEP     (0x20)   /*   |  TYP 1 Commands  */
+#define FDC1772CMD_STIN     (0x40)   /*   |                  */
+#define FDC1772CMD_STOT     (0x60)   /*  -                   */
+#define FDC1772CMD_RDSEC    (0x80)   /*  -   TYP 2 Commands  */
+#define FDC1772CMD_WRSEC    (0xa0)   /*  -          "        */
+#define FDC1772CMD_RDADR    (0xc0)   /*  -                   */
+#define FDC1772CMD_RDTRA    (0xe0)   /*   |  TYP 3 Commands  */
+#define FDC1772CMD_WRTRA    (0xf0)   /*  -                   */
+#define FDC1772CMD_FORCI    (0xd0)   /*  -   TYP 4 Command   */
+
+/* command modifier bits */
+
+#define FDC1772CMDADD_SR6   (0x00)   /* step rate settings */
+#define FDC1772CMDADD_SR12  (0x01)
+#define FDC1772CMDADD_SR2   (0x02)
+#define FDC1772CMDADD_SR3   (0x03)
+#define FDC1772CMDADD_V     (0x04)   /* verify */
+#define FDC1772CMDADD_H     (0x08)   /* wait for spin-up */
+#define FDC1772CMDADD_U     (0x10)   /* update track register */
+#define FDC1772CMDADD_M     (0x10)   /* multiple sector access */
+#define FDC1772CMDADD_E     (0x04)   /* head settling flag */
+#define FDC1772CMDADD_P     (0x02)   /* precompensation */
+#define FDC1772CMDADD_A0    (0x01)   /* DAM flag */
+
+/* status register bits */
+
+#define	FDC1772STAT_MOTORON	(0x80)   /* motor on */
+#define	FDC1772STAT_WPROT	(0x40)   /* write protected (FDC1772CMD_WR*) */
+#define	FDC1772STAT_SPINUP	(0x20)   /* motor speed stable (Type I) */
+#define	FDC1772STAT_DELDAM	(0x20)   /* sector has deleted DAM (Type II+III) */
+#define	FDC1772STAT_RECNF	(0x10)   /* record not found */
+#define	FDC1772STAT_CRC		(0x08)   /* CRC error */
+#define	FDC1772STAT_TR00	(0x04)   /* Track 00 flag (Type I) */
+#define	FDC1772STAT_LOST	(0x04)   /* Lost Data (Type II+III) */
+#define	FDC1772STAT_IDX		(0x02)   /* Index status (Type I) */
+#define	FDC1772STAT_DRQ		(0x02)   /* DRQ status (Type II+III) */
+#define	FDC1772STAT_BUSY	(0x01)   /* FDC1772 is busy */
+
+
+/* PSG Port A Bit Nr 0 .. Side Sel .. 0 -> Side 1  1 -> Side 2 */
+#define DSKSIDE     (0x01)
+        
+#define DSKDRVNONE  (0x06)
+#define DSKDRV0     (0x02)
+#define DSKDRV1     (0x04)
+
+/* step rates */
+#define	FDC1772STEP_6	0x00
+#define	FDC1772STEP_12	0x01
+#define	FDC1772STEP_2	0x02
+#define	FDC1772STEP_3	0x03
+
+#endif
